local StowKeybind = {}
local bagId, slotId, stackCount

function StowKeybind_OnHotkey()
	CallSecureProtected("RequestMoveItem", bagId, slotId, BAG_VIRTUAL, GetNextVirtualBagSlotId(nil), stackCount)
end

ZO_CreateStringId("SI_BINDING_NAME_STOW_KEYBIND", "Stow Hotkey")
local stripDescriptor = StowKeyStrip:New("Stow", "STOW_KEYBIND", StowKeybind_OnHotkey)

function StowKeybind.OnMouseEnter(control)
	bagId  		= control.dataEntry.data.bagId
	slotId 		= control.dataEntry.data.slotIndex
	stackCount 	= control.dataEntry.data.stackCount
	
	stripDescriptor:Add(CanItemBeVirtual(bagId, slotId))
	
end

function StowKeybind.OnMouseExit(control)
	bagId  = nil
	slotId = nil
	stackCount = nil

	stripDescriptor:Remove()
end

local function registerInventoryHotkeys()
	
	for _, index in pairs({INVENTORY_BACKPACK, INVENTORY_BANK}) do	
		local listView = PLAYER_INVENTORY.inventories[index].listView
		if listView and listView.dataTypes and listView.dataTypes[1] then
			local originalCallback = listView.dataTypes[1].setupCallback
			listView.dataTypes[1].setupCallback = function(rowControl, slot)
				originalCallback(rowControl, slot)
				ZO_PreHookHandler(rowControl, "OnMouseEnter", StowKeybind.OnMouseEnter)
				ZO_PreHookHandler(rowControl, "OnMouseExit",  StowKeybind.OnMouseExit)
			end
		end
	end	
	
end

function StowKeybind_Initialize(eventCode, addonName)

	if addonName ~="StowKeybind" then return end
	EVENT_MANAGER:UnregisterForEvent("StowKeybind", EVENT_ADD_ON_LOADED)
	if not IsESOPlusSubscriber() then
		d("This AddOn won't do anything for you without ESO+ and craft")
	end
	registerInventoryHotkeys()
end


EVENT_MANAGER:RegisterForEvent("StowKeybind", EVENT_ADD_ON_LOADED, StowKeybind_Initialize)
