StowKeyStrip = ZO_Object:Subclass()

function StowKeyStrip:New(name, keybind, callback, alignment)
	local obj = ZO_Object.New(self)
	obj:Init(name, keybind, callback, alignment)
	return obj
end

function StowKeyStrip:Init(name, keybind, callback, alignment)
	local function createStripDescriptor(name, keybind, callback, alignment)
		return {{
			alignment = alignment or KEYBIND_STRIP_ALIGN_RIGHT,
			name = name,
			keybind = keybind,
			callback = callback
		}}
	end
	self.stripDescriptor = createStripDescriptor(name, keybind, callback, alignment)
	self.wasAdded = false
end

function StowKeyStrip:Add(condition)
	if (not condition) or self.wasAdded then return end	
	KEYBIND_STRIP:AddKeybindButtonGroup(self.stripDescriptor)
	self.wasAdded = true
	
end

function StowKeyStrip:Remove()
	if (self.wasAdded) then
		KEYBIND_STRIP:RemoveKeybindButtonGroup(self.stripDescriptor)
		self.wasAdded = false
	end
end